'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var ReactDOM = require('react-dom');

var _require = require('material-ui/Table'),
    Table = _require.Table,
    TableBody = _require.TableBody,
    TableRow = _require.TableRow,
    TableRowColumn = _require.TableRowColumn;

var _require2 = require('react-intl'),
    FormattedMessage = _require2.FormattedMessage;

var assign = require('object-assign');
var msg = require('../util/intl_helpers').createMessage;

var styles = {
  firstColumn: {
    fontWeight: 'bold'
  }
};

var FeatureTable = function (_React$Component) {
  _inherits(FeatureTable, _React$Component);

  function FeatureTable() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FeatureTable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FeatureTable.__proto__ || Object.getPrototypeOf(FeatureTable)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      width: '50%'
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FeatureTable, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.autoFitColumn();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (this.props.data !== prevProps.data) {
        this.autoFitColumn();
      }
    }
  }, {
    key: 'autoFitColumn',
    value: function autoFitColumn() {
      var _this2 = this;

      var width = 0;
      this.props.data.forEach(function (row) {
        var rowEl = ReactDOM.findDOMNode(_this2.refs[row.key]);
        width = Math.max(width, rowEl.offsetWidth);
      });
      this.setState({
        width: width
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var data = this.props.data;

      return React.createElement(
        Table,
        { selectable: false },
        React.createElement(
          TableBody,
          { displayRowCheckbox: false, preScanRows: false },
          data.map(function (row, i) {
            return React.createElement(
              TableRow,
              { key: row.key },
              React.createElement(
                TableRowColumn,
                { ref: '__td' + i, style: assign({}, styles.firstColumn, { width: _this3.state.width }) },
                React.createElement(
                  'span',
                  { ref: row.key },
                  React.createElement(FormattedMessage, msg('field_key')(row.key))
                )
              ),
              React.createElement(
                TableRowColumn,
                null,
                React.createElement(FormattedMessage, msg('field_value')(row.value))
              )
            );
          })
        )
      );
    }
  }]);

  return FeatureTable;
}(React.Component);

module.exports = FeatureTable;