'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var _require = require('react-redux'),
    connect = _require.connect;

var routerContextType = require('react-router/PropTypes').routerContext;
var MapView = require('../components/map_view');

var _require2 = require('../action_creators'),
    moveMap = _require2.moveMap;

var getMapGeoJSON = require('../selectors/map_geojson');
var getMapBoxFilter = require('../selectors/mapbox_filter');
var getFieldMapping = require('../selectors/field_mapping');

var assign = require('object-assign');
var deepEqual = require('deep-equal');
var roundTo = require('round-to');

var MapContainer = function (_React$Component) {
  _inherits(MapContainer, _React$Component);

  function MapContainer() {
    _classCallCheck(this, MapContainer);

    return _possibleConstructorReturn(this, (MapContainer.__proto__ || Object.getPrototypeOf(MapContainer)).apply(this, arguments));
  }

  _createClass(MapContainer, [{
    key: 'componentWillMount',


    // Read the map position from the URL on first load
    value: function componentWillMount() {
      var _props = this.props,
          center = _props.center,
          zoom = _props.zoom,
          query = _props.location.query,
          onMove = _props.onMove;

      query = query || {};
      // If `center` and `zoom` are not set, try to read from the URL query
      // parameter and update the application state.
      var isUrlValid = !isNaN(+query.lng) && !isNaN(+query.lat) && !isNaN(+query.z);
      if ((!center || !zoom) && isUrlValid) {
        onMove({
          zoom: +query.z,
          center: [+query.lng, +query.lat]
        });
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props2 = this.props,
          center = _props2.center,
          zoom = _props2.zoom,
          location = _props2.location;
      var router = this.context.router;

      if (deepEqual(center, nextProps.center) && zoom === nextProps.zoom) return;
      // If `mapPosition` has changed, update URL query string to new value
      var newQuery = assign({}, nextProps.location.query, {
        z: nextProps.zoom && roundTo(nextProps.zoom, 2),
        lng: nextProps.center && roundTo(nextProps.center[0], 4),
        lat: nextProps.center && roundTo(nextProps.center[1], 4)
      });
      var newLocation = assign({}, location, {
        search: null,
        query: newQuery
      });
      router.transitionTo(newLocation);
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(MapView, this.props);
    }
  }]);

  return MapContainer;
}(React.Component);

MapContainer.contextTypes = {
  router: routerContextType.isRequired
};


function mapStateToProps(state) {
  return {
    center: state.mapPosition.center,
    zoom: state.mapPosition.zoom,
    geojson: getMapGeoJSON(state),
    filter: getMapBoxFilter(state),
    fieldMapping: getFieldMapping(state)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    onMove: function onMove(mapPosition) {
      return dispatch(moveMap(mapPosition));
    }
  };
}

module.exports = connect(mapStateToProps, mapDispatchToProps)(MapContainer);